package gov.inl;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.Writer;
import java.util.Map;

import javax.faces.context.FacesContext;
import javax.servlet.GenericServlet;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class DumpStack extends HttpServlet
{

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException
    {
        try
        {
            resp.setContentType("text/plain");

            PrintWriter out = resp.getWriter();
            out.println("Thread dump at start time");
            out.println("=========================");
            out.println();
            dumpAll(out);

            Thread.sleep(5000);
            out.println();
            out.println();
            out.println();
            out.println();
            out.println();
            out.println("Thread dump at start +5s");
            out.println("=========================");
            out.println();
            dumpAll(out);

            Thread.sleep(5000);
            out.println();
            out.println();
            out.println();
            out.println();
            out.println();
            out.println("Thread dump at start +10s");
            out.println("=========================");
            out.println();
            dumpAll(out);

            out.println();
            out.println("*** END ***");
        }
        catch (InterruptedException e)
        {
            throw new ServletException(e);
        }
    }

    private static void dumpAll(PrintWriter out)
    {
        Map<Thread, StackTraceElement[]> dump = Thread.getAllStackTraces();

        for (Thread thread : dump.keySet())
        {
            out.println();
            out.println("Thread: " + thread.getName() + " priority:" + thread.getPriority() + " daemon:" + thread.isDaemon() + " threadId:" + thread.getId()
                    + " threadState:" + thread.getState());
            for (StackTraceElement stackTraceElement : dump.get(thread))
            {
                out.println("\t" + stackTraceElement);
            }
        }
    }

}
